/****************************************************************************
*      Project: Blue Box
*         File: disptabl.c
*      Revison: 0.01 12/29/97    rjs   Created
*  Description: This file contains the display string and function tables used by the parameter 
*				display routines.
*****************************************************************************/

/*  every unit has an entry in _either_ unit_function_ptrs[]
 *  _or_ unit_string_table_ptrs[] not both
 */

const UNIT_FUNCT_PTR unit_function_ptrs[NUM_TYPES_OF_DISP_UNITS] =
{
/* unipolar units */
	&display_in_mix_units, 			/* MIX_DISP_UNITS */
	&display_in_no_units,			/* NO_DISP_UNITS */
	NULL,					/* WAVEFORM_DISP_UNITS */
	&display_in_percentage_units,		/* PERCENTAGE_DISP_UNITS */
	NULL,					/* ON_OFF_DISP_UNITS */
	NULL,					/* LOG_LIN_DISP_UNITS */
	NULL,					/* NOTE_DISP_UNITS */
	&display_in_off_decimal_units,		/* OFF_DECIMAL_DISP_UNITS */
	&display_in_time_sig_units,			/* TEMPO_RATIO_DISP_UNITS */
	&display_in_Hz_units,			/* HZ_DISP_UNITS */
	&display_in_Q_units,			/* Q_DISP_UNITS */
	NULL,					/* ENVELOPE_DISP_UNITS */
	NULL,					/* VELOCITY_DISP_UNITS */
	NULL,					/* MODULATION_DISP_UNITS */
	&display_in_degree_units,			/* DEGREE_DISP_UNITS */
	&display_in_time_sig_units,			/* MS_OR_TIME_SIG_DISP_UNITS */
	NULL,								/* LOAD_MODE_DISP_UNITS */
	NULL,								/* LFO_MODE_DISP_UNITS */
	NULL,								/* ADSR_MODE_DISP_UNITS */
	&display_in_rate_unit_units,		/* RATE_DISP_UNITS_DISP_UNITS */
	&display_in_time_unit_units,		/* TIME_DISP_UNITS_DISP_UNITS */
	&display_in_feedback_insert_units,	/* FB_INSERT_DISP_UNITS */
	NULL,								/* TAP_MODE_DISP_UNITS */
	&display_in_rate_units,				/* RATE_DISP_UNITS */
	&display_in_midi_channel_units,		/* MIDI_CHANNEL_DISP_UNITS */
	NULL, 					/* MIDI_OUT_RATE_DISP_UNITS	*/
	NULL, 					/* METER_DISP_UNITS	*/
	NULL, 					/* SORT_MODE_DISP_UNITS*/
	NULL, 					/* BYPASS_MODE_DISP_UNITS*/
	NULL, 					/* MEM_PROTECT_DISP_UNITS*/
	NULL, 					/* PATCH_UPDATE_MODE_DISP_UNITS*/
	NULL, 					/* SLEEP_MODE_DISP_UNITS*/
	NULL, 					/* MIX_MODE_DISP_UNITS*/
	NULL, 					/* PROGRAM_LOAD_DISP_UNITS*/
	NULL, 					/* CLOCK_SOURCE_DISP_UNITS*/
	NULL, 					/* AUDIO_OUTPUT_DISP_UNITS*/
	NULL, 					/* CHAN_STAT_DISP_UNITS*/
	&display_in_name_units, 			/* ALPHANUMERIC_DISP_UNITS*/
	&display_in_BPM_units,			/* BPM_DISP_UNITS */
	NULL,					/* TEMPO_SOURCE_DISP_UNITS */
	&display_in_cont_source_units,		/* CONT_SOURCE_DISP_UNITS */
	&display_in_min_off_cont_source_units,	/* MIN_OFF_CONT_SOURCE_DISP_UNITS */
	&display_in_num_beats_units,		/* NUM_BEATS_DISP_UNITS */
	&display_in_options_no_units,		/* OPTIONS_NO_DISP_UNITS */
	NULL,					/* AB_MODE_DISP_UNITS */
	NULL,					/* GLOBAL_PATCH_DEST_DISP_UNITS */
	NULL,					/* UI_DUMP_DISP_UNITS */
	NULL,					/* CHORUS_MODE_DISP_UNITS */
	&display_in_name_units,			/* NAME_DISP_UNITS */
	&display_wah_type_units,		/* WAH_TYPE_DISP_UNITS */
	NULL,					/* INPUT_MODE_DISP_UNITS */
	NULL,					/* ARP_MODE_DISP_UNITS */
	&display_envelope_source_units,		/* ENV_SOURCE_DISP_UNITS */
	&LEXDisplayScale,			// SIZE_DISP_UNITS
	&LEXDisplayTrebDecay,			// TREB_DISP_UNITS
	&LEXDisplayBassRT,			// BASSRT_DISP_UNITS
	&LEXDisplayXover,			// XOVER_DISP_UNITS
	&LEXDisplayMidRT,			// MIDRT_DISP_UNITS
	&LEXDisplayPercent50,			// PERCENT50_DISP_UNITS
	&display_in_ms_units,	//LEXDisplayMSec,			// MSEC_DISP_UNITS
	&LEXDisplaySpread,			// SPREAD_DISP_UNITS
	&display_in_no_units,			// SHAPE_DISP_UNITS
	&LEXDisplaySlope,			// SLOPE_DISP_UNITS
	&LEXDisplayDPLevel,			// DPLEVEL_DISP_UNITS
	&LEXDisplayDuration,			// DURATION_DISP_UNITS
	&display_cromatic_notes,		/* CROMATIC_NOTE_DISP_UNITS */
	&LEXDisplaySPFreq,			// SPFILT_DISP_UNITS
	&display_in_no_units_word,		/* WORD_NO_DISP_UNITS */
	&display_in_dump_units,		/* DUMP_DISP_UNITS */
	&display_in_feet_units,		/* METER_DISP_UNITS */
	&display_in_meter_units,		/* METER_DISP_UNITS */
	&display_in_phase_units,							/* PHASE_DISP_UNITS */	
	&display_in_pdly_units,		/* PDLY_DISP_UNITS */
	&display_in_optimize_units,		/* OPTIMIZE_DISP_UNITS */
	&display_in_arp_velocity_source_units,		/* ARP_VELOCITY_SOURCE_DISP_UNITS */
	&display_control_name_units, 		// CONTROL_LEVEL_DISP_UNITS
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	NULL,					/* _DISP_UNITS */
	&display_in_tuner_cal_units,		
	&display_in_patch_dest_units,
	&display_in_cont_group_and_source_units,
	&display_in_soft_row_assign_units,
	&display_diatonic_input_units,
	&display_in_program_name_units,
	&display_in_no_units_word,	/* SAMPLES_DISP_UNITS */
	NULL, 					/* GLOBPROG_MODE_DISP_UNITS*/

/* bipolar units */
	&display_in_level_units, 		/* LEVEL_DISP_UNITS */
	&display_in_coarse_pitch_units, /* FX_1_DISP_UNITS */
	&display_in_bipolar_percentage_units, /* BIPOLAR_PERCENTAGE_DISP_UNITS */
	&display_in_bipolar_no_units,	/* BIPOLAR_NO_DISP_UNITS */
	&display_in_pan_units,			/* PAN_DISP_UNITS */
	&display_bipolar_word,			/* BIPOLAR_WORD_DISP_UNITS */
	&display_in_ff_off_no_units, 	/* FF_OFF_NO_DISP_UNITS*/
	&display_in_bipolar_degrees_units, /* BIPOLAR_DEGREES_DISP_UNITS */
	&display_in_bal_units,			/* BAL_DISP_UNITS */
	&display_in_tone_level_units,		/* TONE_LEVEL_DISP_UNITS */
	&display_in_signed_bargraph_units,
	&display_in_tuner_offset_units,		/* _DISP_UNITS */
	&display_in_inverted_level_units, 		/* LEVEL_DISP_UNITS */
	&display_in_mix_or_dry_units,		/* MIX_OR_DRY_DISP_UNITS */
	&display_in_level_2_units,		/* LEVEL_2_DISP_UNITS */
};


const char **unit_string_table_ptrs[NUM_TYPES_OF_DISP_UNITS] =
{
/* unipolar units */
	NULL, 					/* MIX_DISP_UNITS */
	NULL,					/* NO_DISP_UNITS */
	&waveform_strings[0],			/* WAVEFORM_DISP_UNITS */
	NULL,					/* PERCENTAGE_DISP_UNITS */
	&on_off_strings[0],			/* ON_OFF_DISP_UNITS */
	&log_lin_strings[0],			/* LOG_LIN_DISP_UNITS */
	&note_strings[0],			/* NOTE_DISP_UNITS */
	NULL,					/* OFF_DECIMAL_DISP_UNITS */
	NULL,					/* TEMPO_RATIO_DISP_UNITS */
	NULL,					/* HZ_DISP_UNITS */
	NULL,					/* Q_DISP_UNITS */
	&envelope_mode_strings[0],		/* ENVELOPE_DISP_UNITS */
	&velocity_mode_strings[0],		/* VELOCITY_DISP_UNITS */
	&modulation_mode_strings[0],		/* MODULATION_DISP_UNITS */
	NULL,					/* DEGREE_DISP_UNITS */
	NULL,					/* MS_OR_TIME_SIG_DISP_UNITS */
	&load_mode_strings[0],				/* LOAD_MODE_DISP_UNITS */
	&lfo_mode_strings[0],			/* LFO_MODE_DISP_UNITS */
	&adsr_mode_strings[0],			/* ADSR_MODE_DISP_UNITS */
	NULL,					/* RATE_DISP_UNITS_DISP_UNITS */
	NULL,			/* TIME_DISP_UNITS_DISP_UNITS */
	NULL,						/* FB_INSERT_DISP_UNITS */
	&tap_mode_strings[0],			/* TAP_MODE_DISP_UNITS */
	NULL,					/* RATE_DISP_UNITS */
	NULL,					/* MIDI_CHANNEL_DISP_UNITS */
	&midi_out_rate_strings[0], 		/* MIDI_OUT_RATE_DISP_UNITS	*/
	&meter_strings[0], 			/* METER_DISP_UNITS	*/
	&sort_mode_strings[0], 			/* SORT_MODE_DISP_UNITS*/
	&bypass_mode_strings[0], 		/* BYPASS_MODE_DISP_UNITS*/
	&mem_protect_mode_strings[0],		/* MEM_PROTECT_DISP_UNITS*/
	&patch_update_mode_strings[0],		/* PATCH_UPDATE_MODE_DISP_UNITS*/
	&sleep_mode_strings[0],			/* SLEEP_MODE_DISP_UNITS*/
	&mix_mode_strings[0], 			/* MIX_MODE_DISP_UNITS*/
	&program_load_strings[0], 		/* PROGRAM_LOAD_DISP_UNITS*/
	&clock_source_strings[0], 		/* CLOCK_SOURCE_DISP_UNITS*/
	&audio_output_mode_strings[0],		/* AUDIO_OUTPUT_DISP_UNITS*/
	&chan_stat_mode_strings[0],		/* CHAN_STAT_DISP_UNITS*/
	NULL, 					/* ALPHANUMERIC_DISP_UNITS*/
	NULL,					/* BPM_DISP_UNITS */
	&tempo_source_strings[0],		/* TEMPO_SOURCE_DISP_UNITS */
	NULL,							/* CONT_SOURCE_DISP_UNITS */
	NULL,							/* GLOBAL_CONT_SOURCE_DISP_UNITS */
	NULL,							/* NUM_BEATS_DISP_UNITS */
	NULL,							/* OPTIONS_NO_DISP_UNITS */
	&ab_mode_strings[0],			/* AB_MODE_DISP_UNITS */
	&global_patch_dest_strings[0],	/* GLOBAL_PATCH_DEST_DISP_UNITS */
	&midi_dump_strings[0],			/* UI_DUMP_DISP_UNITS */
	&eq_mode_strings[0],			/* CHORUS_MODE_DISP_UNITS */
	NULL,							/* NAME_DISP_UNITS */
	NULL,							/* WAH_TYPE_DISP_UNITS */
	&input_mode_strings[0],			/* INPUT_MODE_DISP_UNITS */
	&arpeggiator_mode_strings[0],	/* ARP_MODE_DISP_UNITS */
	NULL,							/* ENV_SOURCE_DISP_UNITS */
	NULL,							/* CROMATIC_NOTE_DISP_UNITS */
	NULL,							/* DUMP_DISP_UNITS */
	NULL,							/* FEET_DISP_UNITS */
	NULL,							/* METER_DISP_UNITS */
	NULL,							/* PHASE_DISP_UNITS */
	NULL,							/* PDLY_DISP_UNITS */
	NULL,							/* OPTIMIZE_DISP_UNITS */
	NULL,							/* ARP_VELOCITY_SOURCE_DISP_UNITS */
	NULL,							/* CONTROL_LEVEL_DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	NULL,							/* _DISP_UNITS */
	&on_off_with_bin_strings[0],
	&DSP_bypass_strings[0],
	&tone_strings[0],
	&mojo_bypass_strings[0],
	&SX_bypass_strings[0],
	&feel_strings[0],
	&send_sel_strings[0],
	&sum_mono_strings[0],
	&left_ins_strings[0],
	&spkr_sim_bypass_strings[0],
	&rt_ins_ct_strings[0],
	&mix_insert_strings[0],
	&mute_strings[0],
	&send_bypass_mode_strings[0],
	&post_bypass_mode_strings[0],
	&insert_mode_strings[0],
	&tuner_bypass_mode_strings[0],
	&noise_gate_enable_strings[0],
	&cabinet_strings[0],
	&toe_patch_strings[0],
	&cromatic_note_strings[0],
	&scale_strings[0],
	&interval_strings[0],
	&pitch_detect_source_strings[0],
	&insert_type_strings[0],
	&speaker_freq_strings[0],
	NULL,		/* TUNER_CAL_DISP_UNITS */
	NULL,		/* PATCH_DEST_DISP_UNITS */
	NULL,		/* CONT_GROUP_AND_SOURCE */
	NULL,		/*  */
	NULL,		/* DIATONIC_INPUT */
	NULL,		/* PROGRAM_NAME */
	NULL,		/* SAMPLES_DISP_UNITS */
	&globprog_mode_strings[0], 			/* GLOBPROG_MODE_DISP_UNITS*/

/* bipolar strings */
	NULL, 		/* LEVEL_DISP_UNITS */
	NULL, 		/* FX_1_DISP_UNITS */
	NULL,	 	/* BIPOLAR_PERCENTAGE_DISP_UNITS */
	NULL,		/* BIPOLAR_NO_DISP_UNITS */
	NULL,		/* PAN_DISP_UNITS */
	NULL,		/* BIPOLAR_WORD_DISP_UNITS */
	NULL, 		/* FF_OFF_NO_DISP_UNITS*/
	NULL, 		/* BIPOLAR_DEGREES_DISP_UNITS*/
	NULL, 		/* BAL_DISP_UNITS*/
	NULL,		/* TONE_LEVEL_DISP_UNITS */
	NULL,		/* SIGNED_BARGRAPH_1_DISP_UNITS */
	NULL,		// tuner offset
	NULL,		// inverted_level
	NULL,		/* MIX_OR_DRY_DISP_UNITS */
	NULL,		/* LEVEL_2_DISP_UNITS */
};
